#ifndef __XMLIO_EXCEPTION__
#define __XMLIO_EXCEPTION__

// Classes utilisées issues de la STL
using std::string;

// Classes utilisées issues de Poco
using Poco::Exception;

namespace XMLIOSERVER
{

   class XMLIOError : public std::ostringstream
   {
      private :

         class XMLIOException : public Exception
         {
            public :

               XMLIOException(int _code)
                  : Exception(_code)
               { /* Ne rien faire de plus */ }

               XMLIOException(const std::string& _msg, int _code = 0)
                  : Exception(_msg, _code)
               { /* Ne rien faire de plus */ }

               XMLIOException(const std::string& _msg, const std::string& _arg, int _code)
                  : Exception(_msg, _arg, _code)
               { /* Ne rien faire de plus */ }

               XMLIOException(const std::string& _msg, const Poco::Exception& _exc, int _code)
                  : Exception(_msg, _exc, _code)
               { /* Ne rien faire de plus */ }

               XMLIOException(const XMLIOException& _exc)
                  : Exception(_exc)
               { /* Ne rien faire de plus */ }

               ~XMLIOException(void) throw()
               { std::cerr << displayText() << std::endl; }

               XMLIOException& operator = (const XMLIOException& _exc)
               { Exception::operator = (_exc); return *this; }

            public : /* virtual */

               virtual const char* name(void) const throw() { return ("XMLIO>XMLIOException"); }
               virtual const char* className(void) const throw() { return (typeid(*this).name()); }

               virtual Exception* clone(void) const { return new XMLIOException(*this); }
               virtual void rethrow(void) const { throw *this; }

         }; // class XMLIOException

      public :

         XMLIOError(const std::string _msg)
            : msg(_msg)
         { /* Ne rien faire de plus */ }

         ~XMLIOError(void)
         { throw  XMLIOException(msg); }

      private :

         std::string msg;

   }; // class XMLIOException

}// namespace XMLIOSERVER

#endif // __XMLIO_EXCEPTION__
